# Quetzal-CoalTL <img align="right" width="200" src="https://github.com/Becheler/quetzal-CoalTL/blob/media/quetzal.png">

[![Website becheler.github.io](https://img.shields.io/website-up-down-green-red/https/becheler.github.io.svg)](https://quetzal-framework.github.io/quetzal-CoaTL/)
[![GitHub release (latest by date)](https://img.shields.io/github/v/release/Becheler/quetzal-CoalTL)](https://github.com/Quetzal-framework/quetzal-CoaTL/releases)
[![License: GPL v3](https://img.shields.io/badge/License-GPL%20v3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)
![GitHub last commit](https://img.shields.io/github/last-commit/Becheler/quetzal-CoalTL)

# C++ Template Libary for coalescence

Quetzal-CoalTL is a C++20 template scientific library for
simulating the coalescence of gene genealogies in explicit landscapes or
phylogenetic networks.

Its aim is to standardize a library of reusable components to encourage
code reuse.

# Documentation

The documentation lives [here](https://quetzal-framework.github.io/quetzal-CoaTL/).

> :egg::egg::egg: If you are not a C++ programmer,
> then you are unlikely to benefit directly from this library:
> you may prefer instead the [Quetzal-EGGS simulators](https://github.com/Quetzal-framework/quetzal-EGGS).

# Contact

- :email: You are interested? Want to contribute? Want to give some feedback? Don't be shy, [contact me!](abechele@umich.edu)
- :star: You think this is a cool project? Drop a star on GitHub :point_up:
- :bug: A bug? Oopsie daisy! I'll fix it asap if you [email me](abechele@umich.edu) or open an issue :point_up:

# Author

- AUTHOR : Arnaud Becheler
- DATE   : 2016
- LICENCE : This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
- CONTACT : abechele@umich.edu
- WEBSITE : https://becheler.github.io/

# How to cite

Becheler, A, Coron, C, Dupas, S. The Quetzal Coalescence template library: A C++ programmers resource for integrating distributional, demographic and coalescent models. Mol Ecol Resour. 2019; 19: 788– 793. https://doi.org/10.1111/1755-0998.12992

Becheler, A., & Knowles, L. L. (2020). Occupancy spectrum distribution: application for coalescence simulation with generic mergers. Bioinformatics, 36(10), 3279-3280.
